#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Chart;

namespace GetPointByValueBarRenderer
{
  /// <summary>
  /// Summary description for Form1.
  /// </summary>
  public class MainForm : System.Windows.Forms.Form
  {
    private System.ComponentModel.IContainer components;
    private System.Windows.Forms.ToolTip toolTip = null;
    private ChartControl chartControl = null;

    public MainForm()
    {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();

      //
      // TODO: Add any constructor code after InitializeComponent call
      //
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose( bool disposing )
    {
      if( disposing )
      {
        if (components != null) 
        {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }

    #region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      this.components = new System.ComponentModel.Container();
      System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
      this.chartControl = new Syncfusion.Windows.Forms.Chart.ChartControl();
      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
      this.SuspendLayout();
      // 
      // chartControl
      // 
      this.chartControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right)));
      this.chartControl.BackColor = System.Drawing.Color.White;
      this.chartControl.Controls.Add(this.chartControl.Legend);
      this.chartControl.Depth = 50F;
      // 
      // chartControl.Legend
      // 
      this.chartControl.Legend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
      this.chartControl.Legend.BackColor = System.Drawing.Color.White;
      this.chartControl.Legend.Location = new System.Drawing.Point(250, 20);
      this.chartControl.Legend.Name = "";
      this.chartControl.Legend.Orientation = System.Windows.Forms.Orientation.Horizontal;
      this.chartControl.Legend.Size = new System.Drawing.Size(100, 32);
      this.chartControl.Legend.TabIndex = 3;
      this.chartControl.Location = new System.Drawing.Point(0, 0);
      this.chartControl.Name = "chartControl";
      this.chartControl.PrimaryXAxis.LocationType = Syncfusion.Windows.Forms.Chart.ChartAxisLocationType.Auto;
      this.chartControl.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
      this.chartControl.PrimaryXAxis.TickLabelsDrawingMode = Syncfusion.Windows.Forms.Chart.ChartAxisTickLabelDrawingMode.AutomaticMode;
      this.chartControl.PrimaryXAxis.ZoomFactor = 1;
      this.chartControl.PrimaryXAxis.ZoomPosition = 0;
      this.chartControl.PrimaryYAxis.LocationType = Syncfusion.Windows.Forms.Chart.ChartAxisLocationType.Auto;
      this.chartControl.PrimaryYAxis.TickLabelsDrawingMode = Syncfusion.Windows.Forms.Chart.ChartAxisTickLabelDrawingMode.AutomaticMode;
      this.chartControl.PrimaryYAxis.ZoomFactor = 1;
      this.chartControl.PrimaryYAxis.ZoomPosition = 0;
      this.chartControl.Rotation = 30F;
      this.chartControl.Size = new System.Drawing.Size(600, 428);
      this.chartControl.Spacing = 10F;
      this.chartControl.TabIndex = 0;
      this.chartControl.Tilt = 30F;
      // 
      // chartControl.ToolBar
      // 
      this.chartControl.ToolBar.BackColor = System.Drawing.Color.White;
      this.chartControl.ToolBar.ButtonBackColor = System.Drawing.SystemColors.ControlLight;
      this.chartControl.ToolBar.ButtonFlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.chartControl.ToolBar.ButtonForeColor = System.Drawing.SystemColors.ActiveBorder;
      this.chartControl.ToolBar.ButtonSize = new System.Drawing.Size(32, 32);
      this.chartControl.ToolBar.Location = new System.Drawing.Point(26, 26);
      this.chartControl.ToolBar.Size = new System.Drawing.Size(112, 50);
      this.chartControl.ToolBar.Visible = false;
      this.chartControl.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chartControl_MouseMove);
      // 
      // MainForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(600, 422);
      this.Controls.Add(this.chartControl);
      this.Name = "MainForm";
      this.Text = "Form1";
      this.Load += new System.EventHandler(this.MainForm_Load);
      this.ResumeLayout(false);

    }
    #endregion

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main() 
    {
      Application.Run(new MainForm());
    }

    private void chartControl_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
    {
      Point mousePoint = new Point( e.X, e.Y );
      ChartPoint chpt = chartControl.ChartArea.GetValueByPoint( new Point( e.X, e.Y ) );
      Point pt = chartControl.ChartArea.GetPointByValue( chpt );

      string text = "Mouse point - " + mousePoint.ToString() +
        "\nResult of method GetValueByPoint - {" + chpt.X.ToString() + "," + chpt.YValues[0].ToString() + "}" +
        "\nResult of method GetPointByValue - " + pt.ToString();


      toolTip.SetToolTip( chartControl, text );
    }

    private void MainForm_Load(object sender, System.EventArgs e)
    {
      // Specify a ChartPalette
      this.chartControl.Model.ColorModel.Palette = ChartColorPalette.Triad;

      InitializeChartData();
    }

    /// <summary>
    /// Initializes the ChartControl's data and sets the Chart type
    /// </summary>
    protected void InitializeChartData()
    {
      int numSeries = 2;
      int numPoints = 10;

      Random random = new Random();
      for(int i = 0; i < numSeries; i++)
      {
        ChartSeries series = this.chartControl.Model.NewSeries("Series " + i);
        for(int j = 0; j < numPoints; j++)
        {
          series.Points.Add(j+1, (double)random.Next(400, 500));
        }
				
        series.Type = ChartSeriesType.Bar;
        series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);
        series.Text = series.Name;
        this.chartControl.Series.Add(series);
      }

      this.chartControl.Indexed = false;
    }

    /// <summary>
    /// Handler for the PrepareStyle event of ChartSeries. 
    /// </summary>
    /// <param name="sender">The ChartSeries object that raises this event.</param>
    /// <param name="args">The event data. Can be modified to change series appearance.</param>
    protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
    {
      // Style formatting using a callback. You can apply the same settings directly on the series style on the
      // point styles.
      ChartSeries series = sender as ChartSeries;
      if(series != null)
      {
        args.Style.DisplayText = true;
        args.Style.TextOrientation = ChartTextOrientation.Right;
        args.Style.TextOffset = 20;
        args.Style.DisplayShadow = true;

        if(series == this.chartControl.Series[0])
        {
          args.Style.Symbol.Shape = ChartSymbolShape.Triangle;
          args.Style.Symbol.Size = new Size(10,10);
          args.Style.Symbol.Color = Color.Crimson;
        }
        else
        {
          args.Style.Symbol.Shape = ChartSymbolShape.Diamond;
          args.Style.Symbol.Size = new Size(10,10);
          args.Style.Symbol.Color = Color.Yellow;
        }
      }
    }  
  }
}
